Magellan Linux

Annotation of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2446 - (hide annotations) (download)
Tue Jan 7 14:56:12 2014 UTC (10 years, 4 months ago) by niro
File size: 17576 byte(s)
-disable old mkinitrd and bootloader functions (will get removed soon) and add includes to support grub1, grub2, mkinitrd and dracut
1 niro 2323 #!/bin/bash
2 niro 2322 # $Id$
3 niro 2320 #
4 niro 2322 # Simple Installation Script
5     # merged from alxinstall-ng and mcore-installer
6 niro 2320 #
7     # Niels Rogalla <niro@magellan-linux.de>
8     #
9    
10 niro 2339 # ignore the environment
11     LC_ALL=C
12 niro 2340 # include dir
13 niro 2333 INSTALLER_LIBDIR="%LIBDIR%"
14    
15 niro 2340 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16     # -> now in images.conf
17     CURRENTLINE=0
18    
19 niro 2397 die()
20     {
21     echo "Error: $@"
22     exit 1
23     }
24    
25 niro 2401 # load common includes
26 niro 2402 for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30 niro 2428 ${INSTALLER_LIBDIR}/functions/bootloader.sh \
31     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
32 niro 2402 ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
33 niro 2401 do
34     if [ -e ${inc} ]
35     then
36     source "${inc}"
37     else
38     die "'${inc}' not found"
39     fi
40     done
41 niro 2332
42 niro 2340 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
43     # -> now in images.conf
44     CDIMAGENAME=""
45     TOTALLINES=""
46     CURRENTLINE=0
47 niro 2334 if [ -e /mnt/cdrom/system/images.conf ]
48     then
49     source /mnt/cdrom/system/images.conf
50 niro 2340 # check if all required variables are set
51     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
52     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
53 niro 2334 else
54     die "/mnt/cdrom/system/images.conf not found"
55     fi
56 niro 2320
57     ### System/Config Version
58     VERSION="%VERSIONTAG%"
59 niro 2332 TITLE="${DEFAULT_TITLE} - ${VERSION}"
60 niro 2320
61 niro 2404 # some sane defaults
62 niro 2343 CDROOT="${DEFAULT_CDROOT}"
63 niro 2342 INSTALLROOT="${DEFAULT_INSTALLROOT}"
64 niro 2404 KERNELPKG="${DEFAULT_KERNELPKG}"
65     KERNELOPTS="${DEFAULT_KERNELOPTS}"
66 niro 2320 GRUBLEGACYOPTS=""
67     GRUB2OPTS=""
68     FDISKPARTIONBELOW256MB=0
69     SPECIALDEVICE=""
70 niro 2404 FORMFACTOR="${DEFAULT_FORMFACTOR}"
71 niro 2332 FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
72 niro 2320
73     #################################################
74     # DIALOG BOXEN #
75     #################################################
76    
77 niro 2409 trap_exit()
78     {
79     is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84    
85     echo $"Installation aborted."
86     exit 1
87     }
88    
89 niro 2336 dialog_die()
90     {
91 niro 2341 ERROR="$1"
92     RETVAL="$?"
93 niro 2320 dialog_install_failure
94     exit 1
95     }
96    
97     dialog_warning()
98     {
99 niro 2398 local retval
100    
101     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
102     retval=$?
103     if [[ ${retval} -eq 1 ]]
104 niro 2320 then
105     clear
106 niro 2398 echo $"The process was aborted."
107 niro 2320 exit 1
108     fi
109     }
110    
111     dialog_setup_hdd_info()
112     {
113 niro 2410 local SHDD="${HDD//\/dev\/}"
114 niro 2320
115 niro 2411 messagebox -h $"[ Harddrive partitioning ]" \
116     $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
117 niro 2320 }
118    
119     dialog_setup_hdd_info_auto()
120     {
121 niro 2410 local SHDD="${HDD//\/dev\/}"
122 niro 2320
123 niro 2411 messagebox -h $"[ Harddrive partitioning ]" \
124     $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
125 niro 2320 }
126    
127     dialog_setup_system_menu()
128     {
129 niro 2412 local mode
130     local retval
131 niro 2320
132 niro 2416 mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
133     $"1:Automatic setup (recommended)" \
134     ":" \
135     $":\Z1Expert modes:\Zn" \
136     $"2:Common IDE-disk (manual setup)")
137 niro 2412 retval=$?
138     [[ ${retval} -eq 1 ]] && return 1
139     if [[ ${retval} -eq 0 ]]
140 niro 2320 then
141 niro 2415 case "${mode}" in
142 niro 2320 "1") run_install_auto ;;
143 niro 2341 "2") run_install_normal ;;
144 niro 2320 "") dialog_setup_system_menu;;
145     esac
146     fi
147     }
148    
149     dialog_hardware_detection()
150     {
151 niro 2417 local message
152 niro 2320
153 niro 2344 run_hardware_detection_disks
154 niro 2320
155 niro 2417 message+=$"Harddrives:\n"
156 niro 2320
157 niro 2344 if [[ ! -z ${ALL_DISKS} ]]
158 niro 2320 then
159 niro 2344 for i in ${ALL_DISKS}
160 niro 2320 do
161 niro 2417 message+="\Z3${i}\Zn "
162 niro 2320 done
163 niro 2417 message+="\n"
164 niro 2320 fi
165    
166 niro 2344 if [[ ! -z ${ALL_CDROMS} ]]
167 niro 2320 then
168 niro 2417 message+="\n"
169     message+=$"Optical disk drives:\n"
170 niro 2344 for i in ${ALL_CDROMS}
171 niro 2320 do
172 niro 2417 message+="\Z3${i}\Zn"
173 niro 2320 done
174 niro 2417 message+="\n"
175 niro 2320 fi
176    
177     # other devices
178     run_hardware_detection
179     case "${SPECIALDEVICE}" in
180 niro 2417 zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
181     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
182     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
183     *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
184 niro 2320 esac
185     if [[ ${FORMFACTOR} = laptop ]]
186     then
187 niro 2417 message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
188 niro 2320 fi
189    
190 niro 2417 messagebox -y 15 -h $"Detected hardware:" "${message}"
191 niro 2320 }
192    
193 niro 2413 dialog_setup_hdd_partitions_manual()
194 niro 2320 {
195     local i
196 niro 2422 local retval
197 niro 2320
198 niro 2418 if [[ -z ${ALL_DISKS} ]]
199 niro 2320 then
200 niro 2421 dialog_no_harddrive_found
201 niro 2320 exit 1
202     else
203 niro 2422 HDD=$(dialog_select_target_harddrive)
204     retval=$?
205     [[ ${retval} -eq 1 ]] && return 1
206     if [[ ${retval} -eq 0 ]]
207 niro 2320 then
208     dialog_setup_hdd_info
209 niro 2413 setup_hdd_partitions_manual
210 niro 2320 fi
211     fi
212     }
213    
214     dialog_setup_hdd_partitions_auto()
215     {
216     local i
217 niro 2422 local retval
218 niro 2320
219 niro 2419 if [[ -z ${ALL_DISKS} ]]
220 niro 2320 then
221 niro 2421 dialog_no_harddrive_found
222 niro 2320 exit 1
223     else
224 niro 2422 HDD=$(dialog_select_target_harddrive)
225     retval=$?
226     [[ ${retval} -eq 1 ]] && return 1
227     if [[ ${retval} -eq 0 ]]
228 niro 2320 then
229     dialog_setup_hdd_info_auto
230     dialog_setup_hdd_create_partitions
231     setup_hdd_partitions_auto
232     fi
233     fi
234     }
235    
236 niro 2423 install_meter()
237 niro 2320 {
238     while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
239     do
240     CURRENTLINE=$(grep -c . /tmp/install.log)
241     PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
242     echo ${PERCENT}
243     sleep 1
244     done
245     rm -f /tmp/install.log
246     return 0
247     }
248    
249     dialog_main()
250     {
251 niro 2424 local method=0
252     local retval
253 niro 2320
254 niro 2424 while [[ ${method} -le 2 ]]
255 niro 2320 do
256 niro 2425 method=$(menubox $"Configuration:" \
257     $"1:Install system" \
258     $"2:Show detected harddrives" \
259     $"3:Exit and reboot" \
260     $"4:Exit and drop into a shell")
261 niro 2424 retval=$?
262     [[ ${retval} -eq 1 ]] && exit 1
263     if [[ ${retval} -eq 0 ]]
264 niro 2320 then
265 niro 2424 case ${method} in
266 niro 2341 "1") dialog_setup_system_menu ;;
267 niro 2320 "2") dialog_hardware_detection ;;
268     "3") install_do_reboot ;;
269     "4") /bin/bash --login -i ;;
270     esac
271     fi
272     done
273     }
274    
275     #################################################
276     # Install Komandos #
277     #################################################
278     run_hardware_detection()
279     {
280     local hwinfo
281    
282     hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
283    
284 niro 2430 ## check for special devices/clients:
285     ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
286     #local removable=0
287     #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
288     #then
289     #for i in /sys/block/[hs]d*/removable
290     #do
291     #if [[ $(< ${i}) = 1 ]]
292     #then
293     #removable=1
294     #fi
295     #done
296 niro 2431 ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
297 niro 2320
298 niro 2430 ## only add this for grub legacy, grub2 detect these settings on its own
299     #export GRUBLEGACYOPTS="rootdelay=8"
300     ## there are to zotac types in the wild, nvidia based gfx and intel
301     #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
302     #then
303     #export SPECIALDEVICE="zotac_nvidia"
304     #else
305     #export SPECIALDEVICE="zotac_intel"
306     #fi
307     #fi
308 niro 2320
309     # check for special devices/clients:
310     # if a rangee and disk ist smaller then 256mb move partion one block further ahead
311     if [[ ! -z $(echo "${hwinfo}" | grep -i CLE266) ]]
312     then
313     # for a rangee always define partion startblock +1
314     export FDISKPARTIONBELOW256MB="1"
315     export SPECIALDEVICE="rangee"
316     export GRUBLEGACYOPTS=""
317     fi
318    
319     # check for special devices/clients:
320     # check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
321     if [[ ! -z $(echo "${hwinfo}" | grep -i i810) ]] || [[ ! -z $(echo "${hwinfo}" | grep -i i815) ]]
322     then
323     export SPECIALDEVICE="maxdata"
324     export GRUBLEGACYOPTS=""
325     fi
326    
327     # check for special devices/clients:
328     # check for laptops and activate cpufreq scaling
329     if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
330     then
331     export FORMFACTOR="laptop"
332     export KERNELOPTS="${KERNELOPTS} cpufreq.governor=ondemand"
333     fi
334     }
335    
336 niro 2429 run_hardware_detection_disks()
337     {
338     local bootdev
339    
340     # all disks but exclude ramdisks
341     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
342     # remove the boot device from ALL_DISKS if it was an usbstick
343     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
344     then
345     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
346     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
347     fi
348     export ALL_CDROMS="$(get_hwinfo cdrom)"
349     }
350    
351 niro 2320 hdd_size_below_256mb()
352     {
353     local hdd="$1"
354     local size
355     local retval
356 niro 2336 [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
357 niro 2320
358     size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
359     if [[ ${size} -le 257000000 ]]
360     then
361     retval="0"
362     else
363     retval="1"
364     fi
365    
366     return "${retval}"
367     }
368    
369     setup_hdd_partitions_auto()
370     {
371     ROOTHDD="${HDD}1"
372    
373 niro 2435 # sanity check - should not happen
374     if is_mounted --device "${ROOTHDD}"
375     then
376     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
377     umount "${ROOTHDD}"
378     fi
379    
380 niro 2320 # run this only if FDISKPARTITIONBELOW256MB is not already 1
381     if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
382     then
383     if hdd_size_below_256mb ${HDD}
384     then
385     FDISKPARTIONBELOW256MB=1
386     else
387     FDISKPARTIONBELOW256MB=0
388     fi
389     fi
390    
391     ## delete disk
392 niro 2336 dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
393 niro 2320
394     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
395     then
396     ## setup one bootable partition
397     #1. n= new disk
398     #2. p= primary disk
399     #3. 1= first partition
400     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
401     #5. ''= defaul sector end
402     #6. a= bootable flag
403     #7. 1= boot flag for partition 1
404     #8. w= write/quit
405     fdisk ${HDD} &> /dev/null << EOF
406     n
407     p
408     1
409     2
410    
411     a
412     1
413     w
414     EOF
415     else
416     ## setup one bootable partition
417     #1. n= new disk
418     #2. p= primary disk
419     #3. 1= first partition
420     #4. ''= default sector start
421     #5. ''= defaul sector end
422     #6. a= bootable flag
423     #7. 1= boot flag for partition 1
424     #8. w= write/quit
425     fdisk ${HDD} &> /dev/null << EOF
426     n
427     p
428     1
429    
430    
431     a
432     1
433     w
434     EOF
435     fi
436     }
437    
438 niro 2413 setup_hdd_partitions_manual()
439 niro 2320 {
440     ROOTHDD="${HDD}1"
441 niro 2437 SWAPHDD=""
442     BOOTHDD=""
443 niro 2336 cfdisk ${HDD} || dialog_die
444 niro 2320 }
445    
446     setup_hdd_format()
447     {
448 niro 2435 # sanity check - should not happen
449     if is_mounted --device "${ROOTHDD}"
450     then
451     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
452     umount "${ROOTHDD}"
453     fi
454    
455 niro 2432 mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
456 niro 2320 }
457    
458     install_mount_rootfs()
459     {
460 niro 2435 is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
461 niro 2342 install -d ${INSTALLROOT}/boot || dialog_die
462 niro 2320 }
463    
464     install_system_image()
465     {
466 niro 2433 pushd ${INSTALLROOT} > /dev/null
467 niro 2343 tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
468 niro 2433 popd > /dev/null
469 niro 2320 }
470    
471 niro 2446 disabled_install_bootsector_chroot()
472 niro 2320 {
473     local my_roothdd
474 niro 2444 local grubconf="${INSTALLROOT}/boot/grub/grub.conf"
475     local grub2conf="/boot/grub/grub.cfg"
476 niro 2320
477     # check for grub2
478 niro 2342 if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
479 niro 2320 then
480     # needed by grub-mkconfig on the first run
481 niro 2342 if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
482 niro 2320 then
483 niro 2342 install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
484 niro 2320 fi
485    
486     # set kernelopts
487 niro 2342 if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
488 niro 2320 then
489 niro 2342 sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
490 niro 2320 else
491 niro 2444 CONFIG="${INSTALLROOT}/etc/conf.d/grub"
492     clearconfig
493     addconfig "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\""
494 niro 2320 fi
495 niro 2444 CONFIG="${INSTALLROOT}/root/.installrc"
496     clearconfig
497     # only grub 1.99
498     addconfig 'type -P grub-mkdevicemap && grub-mkdevicemap'
499     addconfig "grub-install --no-floppy ${HDD} &> /dev/null"
500     addconfig "LC_ALL=C grub-mkconfig -o ${grub2conf} &> /dev/null"
501     addconfig "exit 0"
502 niro 2320
503     # grub-legacy
504     else
505 niro 2342 source ${INSTALLROOT}/boot/kernelversion
506 niro 2320
507 niro 2342 if [ -e ${INSTALLROOT}/etc/alx_version ]
508 niro 2320 then
509     OLD_ALXVER="${ALXVER}"
510 niro 2342 source ${INSTALLROOT}/etc/alx_version
511 niro 2320 KRNVER="ALX-${ALXVER}"
512     ALXVER="${OLD_ALXVER}"
513     fi
514    
515     [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
516     [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"
517     [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
518    
519     # uuid support
520 niro 2441 my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
521 niro 2320
522 niro 2444 CONFIG="${grubconf}"
523     clearconfig
524     addconfig "default 0"
525     addconfig "timeout 3"
526 niro 2320 # using current root password
527 niro 2444 addconfig "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"
528 niro 2320
529 niro 2444 addconfig
530     addconfig "# normal boot"
531     addconfig "title ${KRNVER}"
532     addconfig "root (hd0,0)"
533     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}"
534 niro 2320 if is_initrd_supported
535     then
536 niro 2444 addconfig "initrd /boot/${KRNINITRD}"
537 niro 2320 fi
538    
539 niro 2444 addconfig
540     addconfig "# admin boot"
541     addconfig "title ${KRNVER} - Re-run hardware-detection"
542     addconfig "lock"
543     addconfig "root (hd0,0)"
544     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection"
545 niro 2320 if is_initrd_supported
546     then
547 niro 2444 addconfig "initrd /boot/${KRNINITRD}"
548 niro 2320 fi
549    
550 niro 2444 addconfig
551     addconfig "title ${KRNVER} - Reset *all* local settings"
552     addconfig "lock"
553     addconfig "root (hd0,0)"
554     addconfig "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings"
555 niro 2320 if is_initrd_supported
556     then
557 niro 2444 addconfig "initrd /boot/${KRNINITRD}"
558 niro 2320 fi
559    
560     # bootsector schreiben chrooted schreiben (lfs/magellan)
561 niro 2342 cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
562 niro 2320 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
563     root (hd0,0)
564     setup (hd0)
565     quit
566     EOF
567     exit 0
568     CHROOTEOF
569     fi
570    
571 niro 2436 # run installrc
572     chrooted /bin/bash --rcfile /root/.installrc -i
573 niro 2342 rm ${INSTALLROOT}/root/.installrc
574 niro 2320 }
575    
576 niro 2446 disabled_install_initrd_chroot()
577 niro 2320 {
578     # only generate initrds if the cmd exists
579     is_initrd_supported || return 0
580    
581     DISKMODS="sd_mod"
582     OLDPATAMODS="amd74xx piix sis5513 via82cxxx"
583     PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"
584     SATAMODS="sata_via sata_sis sata_nv"
585     DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"
586     OTHERMODS=""
587     case ${SPECIALDEVICE} in
588     zotac_intel) FBMODS=""; DRMMODS="i915" ;;
589     zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;
590     rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards
591     # not working with kms enabled drivers -> segfaults
592     #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
593     maxdata) FBMODS="" ;;
594     *) FBMODS="uvesafb" ;;
595     esac
596    
597     if [[ ${FORMFACTOR} = laptop ]]
598     then
599     OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"
600     fi
601    
602     # install an appropriate uvesafb.conf
603 niro 2342 install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
604 niro 2444 CONFIG="${INSTALLROOT}/etc/modprobe.d/uvesafb.conf"
605     clearconfig
606     addconfig "options uvesafb mode_option=1024x768-32@60 scroll=ywrap"
607 niro 2320
608     # install an appropriate viafb.conf
609 niro 2444 CONFIG="${INSTALLROOT}/etc/modprobe.d/viafb.conf"
610     clearconfig
611     addconfig "options viafb viafb_mode=1024x768 viafb_refresh=60"
612 niro 2320
613     # install an appropriate i810fb.conf
614 niro 2444 CONFIG="${INSTALLROOT}/etc/modprobe.d/i810fb.conf"
615     clearconfig
616     addconfig "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"
617 niro 2320
618 niro 2342 cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
619 niro 2320 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
620     mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
621     exit 0
622     CHROOTEOF
623    
624 niro 2436 # run installrc
625     chrooted /bin/bash --rcfile /root/.installrc -i
626 niro 2342 rm ${INSTALLROOT}/root/.installrc
627 niro 2320 }
628    
629     install_system_settings()
630     {
631 niro 2443 local CONFIG
632 niro 2320
633 niro 2443 # write fstab
634     CONFIG="${INSTALLROOT}/etc/fstab"
635     clearconfig
636     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
637     addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
638     addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
639    
640 niro 2320 # install network config skeleton
641 niro 2443 CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
642     clearconfig
643     addconfig 'ONBOOT="yes"'
644     addconfig 'NETWORKING="dhcp"'
645 niro 2320
646 niro 2442 # intel framebuffer quirk
647     if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
648 niro 2320 then
649 niro 2442 if [ -e /proc/fb ]
650 niro 2320 then
651 niro 2442 if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
652 niro 2320 then
653 niro 2442 fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
654     if [[ ${fbdev} != 0 ]]
655     then
656     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
657     fi
658 niro 2320 fi
659     fi
660     fi
661     }
662    
663     install_umount_rootfs()
664     {
665 niro 2435 is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
666     is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
667 niro 2320 }
668    
669     install_do_reboot()
670     {
671     reboot
672     }
673    
674     #################################################
675     # Install Ablauf Scripte #
676     #################################################
677    
678     run_install_normal()
679     {
680     dialog_hardware_detection
681    
682 niro 2413 dialog_setup_hdd_partitions_manual
683 niro 2320 dialog_setup_hdd_format
684     setup_hdd_format > /dev/null
685     install_mount_rootfs
686 niro 2423 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
687 niro 2320
688     dialog_install_settings
689     sleep 1
690     install_system_settings
691 niro 2440 if is_initrd_supported
692     then
693     dialog_install_initrd
694     initrd_config
695     initrd_install
696     fi
697 niro 2320
698     dialog_install_bootsector
699 niro 2440 bootloader_config
700     bootloader_install
701 niro 2320
702     install_umount_rootfs
703     dialog_install_successful
704     }
705    
706     run_install_auto()
707     {
708     dialog_hardware_detection
709    
710     dialog_setup_hdd_partitions_auto
711     dialog_setup_hdd_format
712 niro 2399 setup_hdd_format > /dev/null
713     install_mount_rootfs
714 niro 2423 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
715 niro 2320
716     dialog_install_settings
717     sleep 1
718 niro 2399 install_system_settings
719 niro 2440 if is_initrd_supported
720     then
721     dialog_install_initrd
722     initrd_config
723     initrd_install
724     fi
725 niro 2320
726     dialog_install_bootsector
727 niro 2440 bootloader_config
728     bootloader_install
729 niro 2320
730 niro 2399 install_umount_rootfs
731 niro 2320 dialog_install_successful
732     }
733    
734 niro 2409 # set some proper traps
735     trap "trap_exit" SIGINT SIGQUIT
736    
737 niro 2320 dialog_main
738    
739     exit 0